
#ifndef _GENERAL_H_
#define _GENERAL_H_

#include <stdio.h>

#if defined(FUNCPROTO) || __STDC__ || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#ifndef NULL
/*
 * NULL --
 *      Null pointer.
 */
#define NULL    ((void *) 0)
#endif
#else
#define ARGS(args) (/*args*/)
#ifndef NULL
/*
 * NULL --
 *      Null pointer.
 */
#define NULL    0
#endif
#endif

/* MAX -- Return the maximum of two numbers. */
/* commonly defined, but how to make sure other definitions are the same? */
#ifndef MAX
#define MAX(x, y)       ((x) > (y) ? (x) : (y))
#endif

/* MIN -- Return the minimum of two numbers. */
#ifndef MIN
#define MIN(x, y)       ((x) < (y) ? (x) : (y))
#endif

/* ABS -- Return the absolute value of the argument. */
#ifndef ABS
#define ABS(x)          ((x) >= 0 ? (x) : -(x))
#endif


#ifndef True
#define True 1
#endif

#ifndef False
#define False 0
#endif

#define NODEBUG
#ifndef NODEBUG

extern int fprintf ARGS((FILE *, const char *, ...));
extern int printf ARGS((const char *, ...));
extern int debug_flag;

#define DBG(f)          {\
                           if (debug_flag){\
                               fprintf(stderr, f);\
                           }\
                         }
#define DBG1(f, a)      {\
                           if (debug_flag){\
                               fprintf(stderr, f, a);\
                           }\
                         }
#define DBG2(f, a, b)   {\
                           if (debug_flag){\
                                fprintf(stderr, f, a, b);\
                           }\
                         }
#define DBG3(f, a, b, c) {\
                           if (debug_flag){\
                                fprintf(stderr, f, a, b, c);\
                           }\
                         }
#define DBG4(f, a, b, c, d) {\
                           if (debug_flag){\
                                fprintf(stderr, f, a, b, c, d);\
                           }\
                         }

#else

#define DBG1(f, a)
#define DBG2(f, a, b)
#define DBG3(f, a, b, c)
#define DBG4(f, a, b, c, d)

#endif

#endif
